extends KinematicBody

onready var camera=get_node("Rotation_Helper/Camera")
onready var rotation_helper=get_node("Rotation_Helper")
onready var lp_TVibros=get_node("Rotation_Helper/Spatial")

const lp_Gravitaciya=-90
const lp_MaxSkorost=5
const lp_SilaPrigka=20
const lp_UgolPodema=40
const lp_Dinamika=6
var lp_OtklikMishki=0.05
var lp_Napravlenie=Vector3()
var lp_Skorost=Vector3()

export (int, 0, 200) var push = 60

func _ready():
	Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED)
	pass


func _input(event):
	if event is InputEventMouseMotion and Input.get_mouse_mode() == Input.MOUSE_MODE_CAPTURED:
		rotation_helper.rotate_x(deg2rad(event.relative.y*lp_OtklikMishki))
		self.rotate_y(deg2rad(event.relative.x*lp_OtklikMishki*-1))

		var camera_rot = rotation_helper.rotation_degrees
		camera_rot.x = clamp(camera_rot.x, -85, 85)
		rotation_helper.rotation_degrees = camera_rot
	pass


func _physics_process(delta):
	process_input(delta)
	process_movement(delta)

	if delta!=0:
		get_node("VBox/Label 2").text="Physics FPS: "+str(round(1/delta))



	for index in get_slide_count():
		var collision = get_slide_collision(index)
		if collision.collider is RigidBody: 
			collision.collider.apply_central_impulse(-collision.normal * push)

	pass


func process_input(delta):
	var vp_Napravlenie=camera.get_global_transform()

	var vp_Vvod=Vector2()
	if is_on_floor():
		if Input.is_action_just_pressed("ui_accept"):
			lp_Skorost.y=lp_SilaPrigka
		lp_Napravlenie=Vector3()
		if Input.is_action_pressed("ui_up"):
			vp_Vvod.y=vp_Vvod.y+1
		if Input.is_action_pressed("ui_down"):
			vp_Vvod.y=vp_Vvod.y-1
		if Input.is_action_pressed("ui_left"):
			vp_Vvod.x=vp_Vvod.x-1
		if Input.is_action_pressed("ui_right"):
			vp_Vvod.x=vp_Vvod.x+1
		vp_Vvod=vp_Vvod.normalized()
		lp_Napravlenie=lp_Napravlenie-vp_Napravlenie.basis.z.normalized()*vp_Vvod.y
		lp_Napravlenie=lp_Napravlenie+vp_Napravlenie.basis.x.normalized()*vp_Vvod.x

	if Input.is_action_pressed("ui_cancel"):
		Global.scn_ZagruzkaPoID("Menu",Vector3())

	pass


func process_movement(delta):
	lp_Napravlenie.y=0
	lp_Napravlenie=lp_Napravlenie.normalized()
	lp_Skorost.y=lp_Skorost.y+delta*lp_Gravitaciya
	var vp_Skorost=lp_Skorost
	vp_Skorost.y=0
	var vp_Napravlenie=lp_Napravlenie
	vp_Napravlenie=vp_Napravlenie*lp_MaxSkorost
	vp_Skorost=vp_Skorost.linear_interpolate(vp_Napravlenie,lp_Dinamika*delta)
	lp_Skorost.x=vp_Skorost.x
	lp_Skorost.z=vp_Skorost.z
	lp_Skorost=move_and_slide(lp_Skorost,Vector3(0,1,0),0.05,4,deg2rad(lp_UgolPodema))
	pass


func _process(delta):

	if Input.is_action_pressed("ui_cancel"):
		Global.scn_ZagruzkaPoID("Menu",Vector3())
	if Input.is_action_pressed("ui_v_SO"):
		Global.scn_AddSO(lp_TVibros.get_global_transform().origin)
	if Input.is_action_pressed("ui_v_BO"):
		Global.scn_AddBO(lp_TVibros.get_global_transform().origin)

	if delta!=0:
		get_node("VBox/Label 1").text="Render FPS: "+str(round(1/delta))

	$VBox/Grid/T1_1.text=str(Global.gp_GSO)
	$VBox/Grid/T1_2.text=str(Global.gp_VSO)
	$VBox/Grid/T1_3.text=str(Global.gp_GSO-Global.gp_VSO)
	$VBox/Grid/T2_1.text=str(Global.gp_GBO)
	$VBox/Grid/T2_2.text=str(Global.gp_VBO)
	$VBox/Grid/T2_3.text=str(Global.gp_GBO-Global.gp_VBO)
	pass


func set_Position(vp_Koordinati):
	set_translation(vp_Koordinati)
	pass
